<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.4
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

define('DIAFAN', 1);
include_once(dirname(__FILE__)."/config.php");

define('IS_ADMIN', 1);
define('IS_INSTALL', 1);

error_reporting(E_ALL);

define("ABSOLUTE_PATH", dirname(__FILE__)."/");

include_once(ABSOLUTE_PATH.'includes/function.php');
include_once(ABSOLUTE_PATH.'includes/http.php');
include_once(ABSOLUTE_PATH.'includes/https.php');
include_once(ABSOLUTE_PATH.'includes/xml.php');
include_once(ABSOLUTE_PATH.'includes/core.php');
require_once(ABSOLUTE_PATH.'includes/database.php');
require_once(ABSOLUTE_PATH.'includes/session.php');
require_once(ABSOLUTE_PATH.'includes/user.php');
include_once(ABSOLUTE_PATH.'includes/init.php');

// Добавляем таблицы родительских связей
$tables = array("site", "menu", "news_category", "clauses_category", "faq_category", "files_category", "photo_category", "subscribtion_category", "shop_category", "forum_category", "forum", "trash", "adminsite");
foreach($tables as $table)
{
	DB::query("DELETE FROM {".$table."_parents}");
	$result = DB::query("SELECT parent_id, id FROM {".$table."}"); 
	while($row = DB::fetch_array($result))
	{
		$parents = parents($row["parent_id"], $table);
		foreach($parents as $p)
		{
			if($p)
			{
				DB::query("INSERT INTO {".$table."_parents} (parent_id, element_id) VALUES('%d', '%d')", $p, $row["id"]);
			}
		}
	}
	$result = DB::query("SELECT id FROM {".$table."}"); 
	while($row = DB::fetch_array($result))
	{
		$count = DB::query_result("SELECT COUNT(*) FROM  {".$table."_parents} WHERE parent_id=%d", $row["id"]);
		DB::query("UPDATE {".$table."} SET count_children=%d WHERE id=%d", $count, $row["id"]);
	}
}

echo 'Обновление успешно завершено!';

function multilang($str)
{
	global $language;
	$result = '';

	$arg = func_get_args();
	$i = 0;

	foreach($language as $lang)
	{
		if(isset($arg[$i]))
		{
			$str = $arg[$i];
		}
		$result .= str_replace('LANG', $lang, $str).' ';
		$i ++;
	}
	return $result;
}

function parents($parent_id, $table)
{
	$array[] = $parent_id;
	while ($parent_id != 0)
	{
		$parent_id = DB::query_result("SELECT parent_id FROM {".$table."} WHERE id = %d", $parent_id);
		if(in_array($parent_id, $array))
		{
			return $array;
		}
		if($parent_id)
		{
			$array[] = $parent_id;
		}
	}
	return $array;
}